/*
* 	Copyright (C) 2012, Pierre Letessier (INA / INRIA), all rights reserved.
*
* 	This file is part of BelgaLogosEval.
*
*   BelgaLogosEval is free software: you can redistribute it and/or modify
*  	it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   BelgaLogosEval is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with BelgaLogosEval.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "Result.h"
#include <string.h>
#include <stdio.h>
#include <stdlib.h>

Result::Result(char* s_query_name, char* s_class_name,
		char* s_result_filename, float f_score, uint32_t ui32_x1,
		uint32_t ui32_y1, uint32_t ui32_x2, uint32_t ui32_y2)
{
	s_query_name_ = (char*) malloc(strlen(s_query_name) + 1);
	sprintf(s_query_name_, "%s", s_query_name);

	s_class_name_ = (char*) malloc(strlen(s_class_name) + 1);
	sprintf(s_class_name_, "%s", s_class_name);

	s_result_filename_ = (char*) malloc(strlen(s_result_filename) + 1);
	sprintf(s_result_filename_, "%s", s_result_filename);

	f_score_ = f_score;
	ui32_x1_ = ui32_x1;
	ui32_y1_ = ui32_y1;
	ui32_x2_ = ui32_x2;
	ui32_y2_ = ui32_y2;

}

Result::~Result()
{
}

char* Result::getQueryName() const
{
	return s_query_name_;
}

char* Result::getClassName() const
{
	return s_class_name_;
}

char* Result::getResultFilename() const
{
	return s_result_filename_;
}

float Result::getScore() const
{
	return f_score_;
}

uint32_t Result::getX1() const
{
	return ui32_x1_;
}

uint32_t Result::getX2() const
{
	return ui32_x2_;
}

uint32_t Result::getY1() const
{
	return ui32_y1_;
}

uint32_t Result::getY2() const
{
	return ui32_y2_;
}

