/*
* 	Copyright (C) 2012, Pierre Letessier (INA / INRIA), all rights reserved.
*
* 	This file is part of BelgaLogosEval.
*
*   BelgaLogosEval is free software: you can redistribute it and/or modify
*  	it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   BelgaLogosEval is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with BelgaLogosEval.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef RESULT_H_
#define RESULT_H_

#ifdef _MSV_VER
	#if _MSV_VER < 1600
		typedef __int16				int16_t;
		typedef unsigned __int16	uint16_t;
		typedef __int32				int32_t;
		typedef unsigned __int32	uint32_t;
		typedef __int64				int64_t;
		typedef unsigned __int64	uint64_t;
	#else
		#include <stdint.h>
	#endif
#else
	#include <stdint.h>
#endif

class Result
{
public:
	Result(char* s_query_name, char* s_class_name,
			char* s_result_filename, float f_score, uint32_t ui32_x1,
			uint32_t ui32_y1, uint32_t ui32_x2, uint32_t ui32_y2);

	~Result();

	char* getQueryName() const;
	char* getClassName() const;
	char* getResultFilename() const;
	float getScore() const;
	uint32_t getX1() const;
	uint32_t getX2() const;
	uint32_t getY1() const;
	uint32_t getY2() const;

private:
	char* s_query_name_;
	char* s_class_name_;
	char* s_result_filename_;
	float f_score_;
	uint32_t ui32_x1_;
	uint32_t ui32_y1_;
	uint32_t ui32_x2_;
	uint32_t ui32_y2_;
};

#endif /* RESULT_H_ */
