/*
* 	Copyright (C) 2012, Pierre Letessier (INA / INRIA), all rights reserved.
*
* 	This file is part of BelgaLogosEval.
*
*   BelgaLogosEval is free software: you can redistribute it and/or modify
*  	it under the terms of the GNU General Public License as published by
*   the Free Software Foundation, either version 3 of the License, or
*   (at your option) any later version.
*
*   BelgaLogosEval is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with BelgaLogosEval.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "ResultManager.h"
#include <iostream>
#include <string.h>
#include <stdio.h>

using namespace std;

ResultManager::ResultManager()
{

}

ResultManager::~ResultManager()
{
}

void ResultManager::addResult(Result result)
{
	a_results.push_back(result);
}

void ResultManager::printResults()
{
	for (vector<Result>::iterator it = a_results.begin(); it != a_results.end();
			++it)
	{
		cout << (*it).getQueryName() << "\t" << (*it).getResultFilename()
				<< "\t" << (*it).getScore() << "\t" << (*it).getX1() << "\t"
				<< (*it).getY1() << "\t" << (*it).getX2() << "\t"
				<< (*it).getY2() << endl;
	}
}

Result ResultManager::getResult(int32_t i32_index)
{
	return a_results.at(i32_index);
}

uint32_t ResultManager::getNumberOfResult()
{
	return a_results.size();
}

int32_t ResultManager::readResultsFromFile(char* s_filename)
{
	FILE* f = fopen(s_filename, "r");
	if (f == NULL)
	{
		printf("ERROR while opening file %s\n", s_filename);
		return 0;
	}
	else
	{

		char s_query_name[512];
		char s_class_name[512];
		char s_result_filename[512];
		float f_score;
		uint32_t ui32_xmin, ui32_xmax, ui32_ymin, ui32_ymax;

		while (true)
		{
			int32_t i32_flag = fscanf(f, (char*) ("%s\t%s\t%f\t%u\t%u\t%u\t%u"),
					s_query_name, s_result_filename, &f_score, &ui32_xmin,
					&ui32_ymin, &ui32_xmax, &ui32_ymax);

			if (i32_flag != 7)
				break;

			char* ptr = strrchr(s_query_name, '_');
			if (ptr == NULL)
			{
				printf("ERROR : ptr is null\n");
				return 0;
			}

			int length = ptr - s_query_name;
			strncpy(s_class_name, s_query_name, length);
			s_class_name[length] = '\0';

			Result* p_result = new Result(s_query_name, s_class_name,
					s_result_filename, f_score, ui32_xmin, ui32_ymin, ui32_xmax,
					ui32_ymax);
			addResult(*p_result);
		}

		fclose(f);
	}

	cout << "The results have been read" << endl;

	return 1;
}
